import java.applet.*;
import java.awt.*;
import java.awt.event.*;

class Snack {
   int x;
   int y;
   int maxX;
   int maxY;

   Snack(int width, int height) {
      maxX = (int) (width/5);
      maxY = (int) (height/5);
      move();
   }         

   public void move() {
      x = ((int) (Math.random() * maxX))*5;
      y = ((int) (Math.random() * maxY))*5;
   }

   public void draw(Graphics g) {
      g.setColor(Color.white);
      g.fillRect(x,y,4,4);
   }

   public void clear(Graphics g) {
      g.setColor(Color.black);
      g.fillRect(x,y,4,4);
   }


   public int ate(int sx, int sy) {
      if ((sx==x)&&(sy==y))
         {
         return 1;
         }  
      else
         return 0;
    }  
}


class Snake {
   int len;
   int dx;
   int dy;
   int x[] = new int[200];
   int y[] = new int[200];
   int maxX;
   int maxY;

   Snake(int width, int height) {
      maxX = width;
      maxY = height;
      x[0] = 0;
      y[0] = 0;
      dx = 5;
      dy = 0;
      len = 3;
   }

   public void move() {
      for (int i=len-1; i > 0; i--) {
          x[i] = x[i-1];
          y[i] = y[i-1]; 
          }
      x[0] = x[0] + dx;
      y[0] = y[0] + dy;
      if (x[0] >= maxX) 
         x[0] = 0;
      else if (x[0] < 0)
         x[0] = maxX-5;
      if (y[0] >= maxY) 
         y[0] = 0;
      else if (y[0] < 0)
         y[0] = maxY-5;
    }

   public void turnLeft() {
      dx = -5;
      dy = 0;
   }

   public void turnRight() {
      dx = 5;
      dy = 0;
   }

   public void turnUp() {
      dx = 0;
      dy = -5;
   }

   public void turnDown() {
      dx = 0;
      dy = 5;
   }

   public int dinner(Snack snack) {
      if (snack.ate(x[0],y[0]) == 1) {
         len++;
         for (int i=len-1; i > 0; i--) {
             x[i] = x[i-1];
             y[i] = y[i-1];         
             }
         x[0] = snack.x;
         y[0] = snack.y;  
         return 1;
         }
      else
         return 0; 
   }


   public void clear(Graphics g) {
      g.setColor(Color.black);
      g.drawRect(x[len-1],y[len-1],4,4);
   }

   public void draw(Graphics g) {
      g.setColor(Color.white);
      g.drawRect(x[0],y[0],4,4);
   }

}

public class GSnake extends Applet implements Runnable, KeyListener, MouseListener {
   private volatile Thread timer;
   private int mulai;
   private Snake oSnake;
   private Snack oSnack;
   Image bgi;
   Graphics bgg;

   public void init() {
      setBackground(Color.black );
      addKeyListener( this );
      addMouseListener(this);
      bgi=createImage(getSize().width,getSize().height);
      bgg=bgi.getGraphics();
      oSnake=new Snake(getSize().width,getSize().height);
      oSnack=new Snack(getSize().width,getSize().height);
      mulai = 0;
   }

   public void start() {
        timer = new Thread(this);
        timer.start();
   }

   public void stop() {
       timer = null;
   }

   public void run() {
        Thread me = Thread.currentThread();
        while (timer == me) {
            try {
                Thread.currentThread().sleep(50);
            } catch (InterruptedException e) {} 
           repaint();
       }
   }

   public void paint(Graphics g) {
       if (mulai == 1) 
          {
          oSnack.draw(bgg);
          oSnake.clear(bgg);  
          oSnake.move();
          if (oSnake.dinner(oSnack)==1) { oSnack.clear(bgg); oSnack.move();}
          oSnake.draw(bgg);
          g.drawImage(bgi,0,0,this);
          }
       else
          {
          g.setColor(Color.white);
          g.drawString("Klik pada applet untuk mulai",10,10);
          }
   }

   public void update(Graphics g) {
        paint(g);
   }

   //by implementing a MouseListener
   public void mouseEntered(MouseEvent event) {
   }
   public void mouseExited(MouseEvent event) {
   }
   public void mousePressed(MouseEvent event) {
   }
   public void mouseReleased(MouseEvent event) {
   }
   public void mouseClicked(MouseEvent event) {
      mulai=1;
   }

   //by implementing a KeyListener
   public void keyPressed( KeyEvent e ) {
      if (e.getKeyCode() == KeyEvent.VK_LEFT) {
         oSnake.turnLeft();
         }
      else if (e.getKeyCode() == KeyEvent.VK_RIGHT) {
         oSnake.turnRight();
         }
      else if (e.getKeyCode() == KeyEvent.VK_UP) {
         oSnake.turnUp();
         }
      else if (e.getKeyCode() == KeyEvent.VK_DOWN) {
         oSnake.turnDown();
         } 
   }
   public void keyReleased( KeyEvent e ) {}
   public void keyTyped( KeyEvent e ) {}
}
